VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "TWindows"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Description = "The collection class that handles TWindow objects."
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"TWindow"
Attribute VB_Ext_KEY = "Member0" ,"TWindow"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' "Debugging Applications" (Microsoft Press)
' Copyright (c) 1997-2000 John Robbins -- All rights reserved.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' API Function Prototypes
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Declare Function IsWindow Lib "user32" _
                        (ByVal hWnd As Long) As Long


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' The class private collection variable that holds everything.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private mCol As Collection

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' The Add method.  If item is either not a valid TWindow or HWND, then
' the item is not added.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Function Add(item As Variant) As TWindow
    Dim TWin As TWindow
    Dim hWndT As Long

    ' Figure out if the variant is a HWND or a TWin.
    If (IsObject(item)) Then
        ' This is some sort of object.  Check that it is not an
        '  empty object.
        If (item Is Nothing) Then
            Set TWin = Nothing
        Else
            mCol.Add item
            Set TWin = item
        End If
    Else
        ' It is an HWND, check that it is valid.
        hWndT = item
        ' I had a nasty bug here only with Win98.  Originally, I
        ' used the expression "1 = IsWindow(hWndT)" to decide if
        ' the window was valid.  Since Win98 sometimes decides that
        ' a value like 7 is TRUE, all of my checks failed.
        If (0 <> IsWindow(hWndT)) Then
            Set TWin = New TWindow
            TWin.hWnd = hWndT
            mCol.Add TWin
        Else
            Set TWin = Nothing
        End If
    End If
    Set Add = TWin
End Function


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Property Get item(vntIndexKey As Variant) As TWindow
Attribute item.VB_UserMemId = 0
  Set item = mCol(vntIndexKey)
End Property


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Property Get Count() As Long
    Count = mCol.Count
End Property


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Sub Remove(vntIndexKey As Variant)
    mCol.Remove vntIndexKey
End Sub


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    Set NewEnum = mCol.[_NewEnum]
End Property


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Sub Class_Initialize()
    Set mCol = New Collection
End Sub


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Sub Class_Terminate()
    Set mCol = Nothing
End Sub

